<?php

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();
jimport('joomla.application.component.model');

class ClubmanagementModelMember extends JModel
{
	private static $_lists = NULL;
	
	public function getYearchartData($filterParams = NULL) {
		$filterParams = (is_null($filterParams) ? array() : $filterParams);
		$cache = &JFactory::getCache();
		//$profiler = new JProfiler();
		//$h = fopen("profiler.txt", "a+");
		$cache->setCaching( 1 );
		$return = $cache->call(array(__CLASS__, '_drawYearschart' ), $filterParams);
		//fwrite($h, $profiler->mark( ' with caching' )."\n");

		//$profiler = new JProfiler();
		//		$return = $this->_drawYearschart($filterParams);
		//fwrite($h, $profiler->mark( ' without caching' )."\n");
		//fclose($h);
		return $return;
	}

	public function _drawYearschart($filterParams = NULL) {
		$filterParams = (is_null($filterParams) ? array() : $filterParams);
		$db = JFactory::getDBO();
		$queryMaleMembers = self::getSubqueryMembers('p1.sex="m"');
		$queryFemaleMembers = self::getSubqueryMembers('p1.sex="f"');
		$queryMembers = self::getSubqueryMembers('');

		$where1 = array();
		$where2 = array();

		if (strtotime($fromdate = addslashes($filterParams['fromdate']))) {
			$where1[] = 'm.member_from>=\''.$fromdate.'\'';
			$where2[] = 'm.member_until>=\''.$fromdate.'\'';
		} else {
			$where1[] = '1';
			$where2[] = '1';
		}
		if (strtotime($untildate = addslashes($filterParams['untildate']))) {
			$where1[] = 'm.member_from<=\''.$untildate.'\'';
			$where2[] = 'm.member_until<=\''.$untildate.'\'';
		} else {
			$where1[] = '1';
			$where2[] = '1';
		}
		
		if(isset($filterParams['section_id']) && !empty($filterParams['section_id'])) {
			$where1[] = 'section_catid = '.intval($filterParams['section_id']);
			$where2[] = 'section_catid = '.intval($filterParams['section_id']);
		}

		$where1 = " AND ".implode(" AND ", $where1);
		$where2 = " AND ".implode(" AND ", $where2);
		$query = "
				SELECT
					m.member_from AS dates,
					TO_DAYS(m.member_from) AS days,
					(".$queryMaleMembers.") AS members_male,
					(".$queryFemaleMembers.") AS members_female,
					(".$queryMembers.") AS members_sum

				FROM #__clubmanagement_membership AS m
				LEFT JOIN #__clubmanagement_people AS p ON m.people_id = p.people_id
				WHERE 
				m.member_from IS NOT NULL
				".$where1."
				GROUP BY m.member_from

				UNION

				SELECT
					m.member_until AS dates,
					TO_DAYS(m.member_until) AS days,
					(".$queryMaleMembers.") AS members_male,
					(".$queryFemaleMembers.") AS members_female,
					(".$queryMembers.") AS members_sum

				FROM #__clubmanagement_membership AS m
				LEFT JOIN #__clubmanagement_people AS p ON m.people_id = p.people_id
				WHERE 
				m.member_until IS NOT NULL
				".$where2."
				GROUP BY m.member_until
				";
/**
				LIMIT 0,5

*/

		$db->setQuery($query);
//echo str_replace('#__', 'jos_', $db->getQuery());
//die();
//print_r($db->loadObjectlist());
		return $db->loadObjectlist();
	}

	private static function getSubqueryMembers($where = '') {
		if(empty($where)) {
			$where = 1;
		}
		$query = "
			SELECT 
				COUNT(p1.people_id)
			FROM #__clubmanagement_membership AS m1 
			LEFT JOIN #__clubmanagement_people AS p1 ON m1.people_id = p1.people_id 
			WHERE (m1.member_from <= dates OR m1.member_from IS NULL) 
			AND (m1.member_until>=dates OR m1.member_until IS NULL) 
			AND ".$where;
		return $query;
	}
	

	public function getLists() {
		if (is_null(self::$_lists)) {
			$context= 'com_clubmanagement.member.list.';

			$filter_fromdate = JFactory::getApplication()->getUserStateFromRequest($context.'filter_fromdate', 'filter_fromdate', "");
			$filter_untildate = JFactory::getApplication()->getUserStateFromRequest($context.'filter_untildate', 'filter_untildate', "");
			$filter_date = JFactory::getApplication()->getUserStateFromRequest($context.'filter_date', 'filter_date', "");
			$filter_male_members = JFactory::getApplication()->getUserStateFromRequest($context.'filter_male_members', 'filter_male_members', 1);
			$filter_female_members = JFactory::getApplication()->getUserStateFromRequest($context.'filter_female_members', 'filter_female_members', 1);

			$show_all_member = JFactory::getApplication()->getUserStateFromRequest($context.'show_all_member', 'show_all_member', 1);
			$show_male_member = JFactory::getApplication()->getUserStateFromRequest($context.'show_male_member', 'show_male_member', 1);
			$show_female_member = JFactory::getApplication()->getUserStateFromRequest($context.'show_female_member', 'show_female_member', 1);

			$fromdate 	= JFactory::getApplication()->getUserStateFromRequest($context.'fromdate', 'fromdate');
			$untildate 	= JFactory::getApplication()->getUserStateFromRequest($context.'untildate', 'untildate');

			//	Filter
			$lists["filter_fromdate"] 		= $filter_fromdate;
			$lists["filter_untildate"] 		= $filter_untildate;
			$lists["filter_date"] 			= $filter_date;
			$lists["filter_male_members"] 	= $filter_male_members;
			$lists["filter_female_members"]	= $filter_female_members;

			$lists["show_all_member"]		= $show_all_member;
			$lists["show_male_member"]		= $show_male_member;
			$lists["show_female_member"]	= $show_female_member;

			$lists["fromdate"]				= $fromdate;
			$lists["untildate"]				= $untildate;
			self::$_lists = $lists;
		}
		return self::$_lists;
	}
	
	//public function getQuery() {
	//	return self::$query;
	//}
	
	public static function getAgegroupstatistics($filterParams=NULL) {
		$filterParams = (is_null($filterParams) ? array() : $filterParams);
		$db = JFactory::getDBO();
//var_dump($filterParams);
		//$lists = &self::getLists();
		$filter_date = $filterParams['filter_date'];
		if (!empty($filter_date)) {
			if ($f=strtotime($filter_date)) {
				$filterdate = "'".date('Y-m-d', $f)."'";
			} else {
				$filterdate = "CURRENT_DATE";
				//self::$_lists['filter_date'] = date('Y-m-d');
			}
		} else {
			$filterdate = "CURRENT_DATE";
			//self::$_lists['filter_date'] = date('Y-m-d');
		}

		$where = array();
		if(isset($filterParams['section_id']) && !empty($filterParams['section_id'])) {
			$where[] = 'm.section_catid = '.intval($filterParams['section_id']);
		}
		$where = " AND ".implode(" AND ", $where);

		$subquery = "
			SELECT 
				COUNT(p1.people_id) 
			FROM #__clubmanagement_people AS p1
			INNER JOIN #__clubmanagement_membership AS m ON m.people_id = p1.people_id 
			WHERE 1
			AND (m.member_from <= ".$filterdate." OR m.member_from IS NULL) AND (m.member_until>=".$filterdate." OR m.member_until IS NULL) 
			AND (
				((
					(((YEAR(".$filterdate.") - YEAR(p1.birthday)) = a.age_from) AND ((DAYOFYEAR(".$filterdate.")-DAYOFYEAR(p1.birthday))>=0))
					OR
					((YEAR(".$filterdate.") - YEAR(p1.birthday)) > a.age_from)
					OR
					(a.age_from IS NULL)
				)
				AND (
					((YEAR(".$filterdate.") - YEAR(p1.birthday)) < (a.age_until+1))
					OR
					(((YEAR(".$filterdate.") - YEAR(p1.birthday)) = (a.age_until+1)) AND ((DAYOFYEAR(".$filterdate.")-DAYOFYEAR(p1.birthday))<0))
					OR
					(a.age_until IS NULL)
				)) 
			)
			AND (m.member_from IS NOT NULL OR m.member_until IS NOT NULL)
			".$where."
		";

		$query = "
			SELECT 
				a.description AS description, a.agegroup_id, a.age_from, a.age_until, ".$filterdate." AS filterdate,
				(
					".$subquery."
					AND p1.sex='m' 
				) AS members_male,
				(
					".$subquery."
					AND p1.sex='f' 
				) AS members_female
			FROM #__clubmanagement_agegroups AS a
			WHERE 1
			ORDER BY a.age_from, a.age_until
		";
		$db->setQuery($query);
		//self::$query = $db->getQuery();
//echo "<h1>asdf</h1>";
//echo str_replace('#__', 'jos_', $db->getQuery());
//echo "<hr/>";
		//$rawdata = $db->loadObjectlist();
		//return $rawdata;
		$tmp = $db->loadObjectlist();

		return $tmp;
	}

	public function getSectionmembers($sid) {
		$db = JFactory::getDBO();
		$query = "
			SELECT 
				p.people_id, 
				p.sex, 
				p.name, 
				p.surname,
				CONCAT(p.surname, ', ', p.name) AS name_complete, 
				m.member_from,
				m.member_until,
				m.passport
			FROM #__clubmanagement_membership AS m
			LEFT JOIN #__clubmanagement_people AS p ON m.people_id = p.people_id
			WHERE m.section_catid = '".intval($sid)."'
			AND ((CURDATE() BETWEEN m.member_from AND m.member_until) OR (CURDATE()>=m.member_from AND m.member_until IS NULL))
			GROUP BY p.people_id
			ORDER BY p.surname			
			";

		$db->setQuery($query);
//echo $db->getQuery();
		//$db->setQuery($query, $this->getState('limitstart'), $this->getState('limit'));
		return $this->_data = $db->loadObjectlist();
	}
	
}
?>